
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enchantsandthings.init;

import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.BuildCreativeModeTabContentsEvent;

import net.minecraft.world.item.CreativeModeTabs;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.core.registries.Registries;

import net.mcreator.enchantsandthings.EnchantsAndThingsMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class EnchantsAndThingsModTabs {
	public static final DeferredRegister<CreativeModeTab> REGISTRY = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, EnchantsAndThingsMod.MODID);

	@SubscribeEvent
	public static void buildTabContentsVanilla(BuildCreativeModeTabContentsEvent tabData) {
		if (tabData.getTabKey() == CreativeModeTabs.FUNCTIONAL_BLOCKS) {
			tabData.accept(EnchantsAndThingsModItems.ENDLESS_BEGININGS.get());
			tabData.accept(EnchantsAndThingsModBlocks.EXP_CRYSTALIZER.get().asItem());
		} else if (tabData.getTabKey() == CreativeModeTabs.COMBAT) {
			tabData.accept(EnchantsAndThingsModItems.WOODEN_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.STONE_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.IRON_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.GOLD_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.DIAMOND_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.NETHERITE_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_ARMOR_HELMET.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_ARMOR_CHESTPLATE.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_ARMOR_LEGGINGS.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_ARMOR_BOOTS.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_SWORD.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_DAGGER.get());
			tabData.accept(EnchantsAndThingsModItems.DIAMOND_SHIELD.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.INGREDIENTS) {
			tabData.accept(EnchantsAndThingsModItems.STRANGE_SCROLL.get());
			tabData.accept(EnchantsAndThingsModItems.SOUL_JAR.get());
			tabData.accept(EnchantsAndThingsModItems.SOUL_JAR_EMPTY.get());
			tabData.accept(EnchantsAndThingsModItems.CREEPER_HIDE.get());
			tabData.accept(EnchantsAndThingsModItems.ANCIENT_NETHER_DRAGON_HORN.get());
			tabData.accept(EnchantsAndThingsModItems.SOUL_STEEL_INGOT.get());
			tabData.accept(EnchantsAndThingsModItems.ENDER_DRAGON_SPIKE.get());
			tabData.accept(EnchantsAndThingsModItems.EXPERIENCE_CRYSTAL_SHARD.get());
			tabData.accept(EnchantsAndThingsModItems.PURGING_STONE.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.TOOLS_AND_UTILITIES) {
			tabData.accept(EnchantsAndThingsModItems.SIMPLE_BACKPACK.get());
			tabData.accept(EnchantsAndThingsModItems.ADVENTURERS_BACKPACK.get());
			tabData.accept(EnchantsAndThingsModItems.DUNGEON_EXPLORERS_BACKPACK.get());
			tabData.accept(EnchantsAndThingsModItems.BACKPACK.get());
			tabData.accept(EnchantsAndThingsModItems.END_TRAVELERS_BACKPACK.get());
			tabData.accept(EnchantsAndThingsModItems.RING_OF_DIMENTION_HOPPING.get());
			tabData.accept(EnchantsAndThingsModItems.FLIGHT_TALISMAN.get());
			tabData.accept(EnchantsAndThingsModItems.RING_OF_DRAGON_FIRE.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_PICKAXE.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_AXE.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_SHOVEL.get());
			tabData.accept(EnchantsAndThingsModItems.SOULSTEEL_HOE.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.FOOD_AND_DRINKS) {
			tabData.accept(EnchantsAndThingsModItems.BOILED_EGG.get());
			tabData.accept(EnchantsAndThingsModItems.PANCAKES.get());
			tabData.accept(EnchantsAndThingsModItems.APPLE_PIE.get());
			tabData.accept(EnchantsAndThingsModItems.SWEET_BERRY_PIE.get());
			tabData.accept(EnchantsAndThingsModItems.SLIMEBALL_PIE.get());
			tabData.accept(EnchantsAndThingsModItems.ENCHANTED_GOLDEN_CARROT.get());
			tabData.accept(EnchantsAndThingsModItems.GRASS_STEW.get());
		}
	}
}
