package net.mcreator.enchantsandthings.procedures;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.event.entity.living.LivingHurtEvent;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundSource;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.BlockPos;

import net.mcreator.enchantsandthings.init.EnchantsAndThingsModEnchantments;
import net.mcreator.enchantsandthings.EnchantsAndThingsMod;

import javax.annotation.Nullable;

@Mod.EventBusSubscriber
public class ChompProcedureProcedure {
	@SubscribeEvent
	public static void onEntityAttacked(LivingHurtEvent event) {
		if (event != null && event.getEntity() != null) {
			execute(event, event.getEntity().level(), event.getEntity().getX(), event.getEntity().getY(), event.getEntity().getZ(), event.getEntity(), event.getSource().getEntity());
		}
	}

	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity, Entity sourceentity) {
		execute(null, world, x, y, z, entity, sourceentity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, double x, double y, double z, Entity entity, Entity sourceentity) {
		if (entity == null || sourceentity == null)
			return;
		if (sourceentity instanceof Player) {
			if ((sourceentity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getEnchantmentLevel(EnchantsAndThingsModEnchantments.CHOMP.get()) == 1) {
				if (world instanceof Level _level) {
					if (!_level.isClientSide()) {
						_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1);
					} else {
						_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1, false);
					}
				}
				EnchantsAndThingsMod.queueServerWork(2, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
			}
			if ((sourceentity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getEnchantmentLevel(EnchantsAndThingsModEnchantments.CHOMP.get()) == 2) {
				if (world instanceof Level _level) {
					if (!_level.isClientSide()) {
						_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1);
					} else {
						_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1, false);
					}
				}
				EnchantsAndThingsMod.queueServerWork(2, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
				EnchantsAndThingsMod.queueServerWork(20, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setYRot(1);
							entityToSpawn.setYBodyRot(1);
							entityToSpawn.setYHeadRot(1);
							entityToSpawn.setXRot(1);
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
			}
			if ((sourceentity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getEnchantmentLevel(EnchantsAndThingsModEnchantments.CHOMP.get()) == 3) {
				if (world instanceof Level _level) {
					if (!_level.isClientSide()) {
						_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1);
					} else {
						_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.evoker.prepare_wololo")), SoundSource.NEUTRAL, 1, 1, false);
					}
				}
				EnchantsAndThingsMod.queueServerWork(2, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
				EnchantsAndThingsMod.queueServerWork(12, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setYRot(1);
							entityToSpawn.setYBodyRot(1);
							entityToSpawn.setYHeadRot(1);
							entityToSpawn.setXRot(1);
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
				EnchantsAndThingsMod.queueServerWork(24, () -> {
					if (world instanceof ServerLevel _level) {
						Entity entityToSpawn = EntityType.EVOKER_FANGS.spawn(_level, BlockPos.containing(x, y, z), MobSpawnType.MOB_SUMMONED);
						if (entityToSpawn != null) {
							entityToSpawn.setYRot(2);
							entityToSpawn.setYBodyRot(2);
							entityToSpawn.setYHeadRot(2);
							entityToSpawn.setXRot(2);
							entityToSpawn.setDeltaMovement((entity.getX()), (entity.getY()), (entity.getZ()));
						}
					}
				});
			}
		}
	}
}
