package net.mcreator.enchantsandthings.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.enchantsandthings.world.inventory.ExpblockGUIMenu;
import net.mcreator.enchantsandthings.network.ExpblockGUIButtonMessage;
import net.mcreator.enchantsandthings.EnchantsAndThingsMod;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class ExpblockGUIScreen extends AbstractContainerScreen<ExpblockGUIMenu> {
	private final static HashMap<String, Object> guistate = ExpblockGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_add_five_experience_points;

	public ExpblockGUIScreen(ExpblockGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("enchants_and_things:textures/screens/expblock_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(new ResourceLocation("enchants_and_things:textures/screens/experience_orb_value_17-36.png"), this.leftPos + 78, this.topPos + 52, 0, 0, 18, 18, 18, 18);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
	}

	@Override
	public void init() {
		super.init();
		button_add_five_experience_points = Button.builder(Component.translatable("gui.enchants_and_things.expblock_gui.button_add_five_experience_points"), e -> {
			if (true) {
				EnchantsAndThingsMod.PACKET_HANDLER.sendToServer(new ExpblockGUIButtonMessage(0, x, y, z));
				ExpblockGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 4, this.topPos + 16, 166, 20).build();
		guistate.put("button:button_add_five_experience_points", button_add_five_experience_points);
		this.addRenderableWidget(button_add_five_experience_points);
	}
}
