
package net.mcreator.enchantsandthings.enchantment;

import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.EquipmentSlot;

import net.mcreator.enchantsandthings.init.EnchantsAndThingsModItems;

public class SoulStealEnchantment extends Enchantment {
	public SoulStealEnchantment(EquipmentSlot... slots) {
		super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.WEAPON, slots);
	}

	@Override
	public boolean canApplyAtEnchantingTable(ItemStack itemstack) {
		return Ingredient.of(new ItemStack(EnchantsAndThingsModItems.WOODEN_DAGGER.get()), new ItemStack(EnchantsAndThingsModItems.STONE_DAGGER.get()), new ItemStack(EnchantsAndThingsModItems.IRON_DAGGER.get()),
				new ItemStack(EnchantsAndThingsModItems.GOLD_DAGGER.get()), new ItemStack(EnchantsAndThingsModItems.DIAMOND_DAGGER.get()), new ItemStack(EnchantsAndThingsModItems.NETHERITE_DAGGER.get()),
				new ItemStack(EnchantsAndThingsModItems.SOULSTEEL_DAGGER.get())).test(itemstack);
	}

	@Override
	public boolean isTreasureOnly() {
		return true;
	}

	@Override
	public boolean isTradeable() {
		return false;
	}
}
