
/*
*	MCreator note: This file will be REGENERATED on each build.
*/
package net.mcreator.enchantsandthings.init;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.village.VillagerTradesEvent;
import net.minecraftforge.common.BasicItemListing;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.npc.VillagerProfession;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.FORGE)
public class EnchantsAndThingsModTrades {
	@SubscribeEvent
	public static void registerTrades(VillagerTradesEvent event) {
		if (event.getType() == VillagerProfession.LIBRARIAN) {
			event.getTrades().get(5).add(new BasicItemListing(new ItemStack(Items.EMERALD, 42), new ItemStack(Items.MOJANG_BANNER_PATTERN), new ItemStack(EnchantsAndThingsModItems.STRANGE_SCROLL.get()), 3, 13, 0.13f));
		}
		if (event.getType() == VillagerProfession.FARMER) {
			event.getTrades().get(3).add(new BasicItemListing(new ItemStack(Items.EMERALD, 20), new ItemStack(Items.APPLE, 3), new ItemStack(EnchantsAndThingsModItems.APPLE_PIE.get()), 3, 10, 0.1f));
		}
		if (event.getType() == EnchantsAndThingsModVillagerProfessions.DRAGONOLOGIST.get()) {
			event.getTrades().get(5).add(new BasicItemListing(new ItemStack(Items.DRAGON_BREATH, 2), new ItemStack(Items.BLAZE_POWDER, 5), new ItemStack(EnchantsAndThingsModItems.ANCIENT_NETHER_DRAGON_HORN.get()), 1, 15, 1f));
			event.getTrades().get(3).add(new BasicItemListing(new ItemStack(Items.DRAGON_HEAD), new ItemStack(Items.NETHERITE_INGOT, 3), new ItemStack(EnchantsAndThingsModItems.ENDER_DRAGON_SPIKE.get(), 3), 5, 7, 0.8f));
			event.getTrades().get(3)
					.add(new BasicItemListing(new ItemStack(EnchantsAndThingsModItems.ENDER_DRAGON_SPIKE.get(), 3), new ItemStack(Items.END_CRYSTAL, 2), new ItemStack(EnchantsAndThingsModItems.RING_OF_DRAGON_FIRE.get()), 10, 5, 0.03f));
			event.getTrades().get(1).add(new BasicItemListing(new ItemStack(Items.PHANTOM_MEMBRANE, 30), new ItemStack(Items.ENDER_EYE, 2), new ItemStack(Items.DRAGON_HEAD), 10, 5, 0.05f));
			event.getTrades().get(2).add(new BasicItemListing(new ItemStack(Items.QUARTZ, 10), new ItemStack(Items.DRAGON_HEAD), new ItemStack(EnchantsAndThingsModItems.ENDLESS_BEGININGS.get()), 10, 5, 1f));
			event.getTrades().get(4).add(new BasicItemListing(new ItemStack(Items.NETHERITE_SCRAP, 5), new ItemStack(Items.PHANTOM_MEMBRANE, 16), new ItemStack(Items.ELYTRA), 10, 5, 0.05f));
			event.getTrades().get(2).add(new BasicItemListing(new ItemStack(EnchantsAndThingsModItems.SOUL_JAR.get()), new ItemStack(Items.NETHERITE_SCRAP, 16), new ItemStack(Items.NETHERITE_UPGRADE_SMITHING_TEMPLATE, 4), 10, 5, 0.05f));
			event.getTrades().get(4)
					.add(new BasicItemListing(new ItemStack(Items.SPIRE_ARMOR_TRIM_SMITHING_TEMPLATE, 10), new ItemStack(Items.EYE_ARMOR_TRIM_SMITHING_TEMPLATE, 10), new ItemStack(EnchantsAndThingsModItems.END_TRAVELERS_BACKPACK.get()), 2, 20, 1f));
			event.getTrades().get(5).add(new BasicItemListing(new ItemStack(Blocks.CHORUS_FLOWER, 12), new ItemStack(Blocks.DEEPSLATE_DIAMOND_ORE, 48), new ItemStack(EnchantsAndThingsModBlocks.EXP_CRYSTALIZER.get()), 1, 35, 1f));
			event.getTrades().get(1).add(new BasicItemListing(new ItemStack(EnchantsAndThingsModItems.CREEPER_HIDE.get()),

					new ItemStack(EnchantsAndThingsModItems.EXPERIENCE_CRYSTAL_SHARD.get(), 3), 10, 5, 0.05f));
		}
	}
}
